from .download import download_zip, download_file
from pathlib import Path
down_path = Path(__file__).parent
xz_url = "addons_file"+"/"+down_path.name+"/"
download_zip(xz_url + "assets.zip",down_path)


bl_info = {
    "name" : "Real Damage",
    "author" : "xz-blender repack",
    "description" : "",
    "blender" : (3, 5, 0),
    "version" : (1, 0, 3),
    "location" : "",
    "warning" : "",
    "doc_url": "", 
    "tracker_url": "",
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews
import os
import random
from .translation.translate import GetTranslationDict



addon_keymaps = {}
_icons = None
visual_scripting_editor = {'sna_selectedobjects': [], }


def sna_update_sna_new_property_08739(self, context):
    sna_updated_prop = self.sna_new_property
    bpy.data.objects['Cube.021'].modifiers['DamagePro_']['Input_29'] = sna_updated_prop
    bpy.context.view_layer.objects.active.update_tag(refresh={'DATA'}, )


def sna_update_sna_new_property_001_D54F3(self, context):
    sna_updated_prop = self.sna_new_property_001
    bpy.context.view_layer.objects.active.modifiers['DamagePro_']['Input_30'] = sna_updated_prop
    bpy.context.view_layer.objects.active.update_tag(refresh={'DATA'}, )


def sna_update_sna_new_property_002_CA25C(self, context):
    sna_updated_prop = self.sna_new_property_002
    bpy.context.view_layer.objects.active.modifiers['DamagePro_']['Input_31'] = sna_updated_prop
    bpy.context.view_layer.objects.active.update_tag(refresh={'DATA'}, )


def sna_pop_message_272A6_B1848(Header, Message, NamedIcon):
    Headers = Header
    Messagers = Message
    Iconers = NamedIcon

    def ShowMessageBox(message = "", title = "Message Box", icon = 'INFO'):

        def draw(self, context):
            self.layout.label(text=message)
        bpy.context.window_manager.popup_menu(draw, title = title, icon = icon)
    #Shows a message box with a message, custom title, and a specific icon
    ShowMessageBox(Messagers, Headers, Iconers)
    return


def property_exists(prop_path, glob, loc):
    try:
        eval(prop_path, glob, loc)
        return True
    except:
        return False


def sna_true_deselect__all_C6336_690A9():
    if (bpy.context.view_layer.objects.selected or bpy.context.view_layer.objects.active):
        exec('bpy.context.view_layer.objects.active = None')
        exec("bpy.ops.object.select_all(action='DESELECT')")


def random_integer(min, max, seed):
    random.seed(seed)
    return random.randint(int(min), int(max))


def random_float(min, max, seed):
    random.seed(seed)
    return random.uniform(min, max)


class SNA_OT_Apply_Modifer_92C02(bpy.types.Operator):
    bl_idname = "sna.apply_modifer_92c02"
    bl_label = "Apply Modifer"
    bl_description = "Add modifer to objects"
    bl_options = {"REGISTER", "UNDO"}
    sna_modifer: bpy.props.StringProperty(name='modifer', description='', options={'HIDDEN'}, default='', subtype='NONE', maxlen=0)

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        if (len(list(bpy.context.view_layer.objects.selected)) > 0):
            visual_scripting_editor['sna_selectedobjects'] = []
            for i_265A2 in range(len(bpy.context.view_layer.objects.selected)):
                if bpy.context.view_layer.objects.selected[i_265A2].type == 'MESH':
                    visual_scripting_editor['sna_selectedobjects'].append(bpy.context.view_layer.objects.selected[i_265A2])
            if property_exists("bpy.data.node_groups[self.sna_modifer]", globals(), locals()):
                pass
            else:
                before_data = list(bpy.data.node_groups)
                bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'Damage39 New.blend') + r'\NodeTree', filename=self.sna_modifer, link=False)
                new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
                appended_3FD41 = None if not new_data else new_data[0]
            sna_true_deselect__all_C6336_690A9()
            for i_4902B in range(len(visual_scripting_editor['sna_selectedobjects'])):
                modifier_9D005 = visual_scripting_editor['sna_selectedobjects'][i_4902B].modifiers.new(name='DamagePro_', type='NODES', )
                modifier_9D005.node_group = bpy.data.node_groups[self.sna_modifer]
            for i_B525C in range(len(visual_scripting_editor['sna_selectedobjects'])):
                visual_scripting_editor['sna_selectedobjects'][i_B525C].select_set(state=True, )
                visual_scripting_editor['sna_selectedobjects'][i_B525C].modifiers['DamagePro_']['Input_14'] = random_integer(1.0, 40.0, None)
                visual_scripting_editor['sna_selectedobjects'][i_B525C].modifiers['DamagePro_']['Input_42'] = random_float(0.004999999888241291, 0.00800000037997961, None)
                visual_scripting_editor['sna_selectedobjects'][i_B525C].modifiers['DamagePro_']['Input_40'] = random_float(1.0, 360.0, None)
        else:
            sna_pop_message_272A6_B1848('Warning', 'No selected objects', 'ERROR')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_PT_REAL_DAMAGE_420D1(bpy.types.Panel):
    bl_label = 'Real Damage'
    bl_idname = 'SNA_PT_REAL_DAMAGE_420D1'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'Real Damage'
    bl_order = 0
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        ac_ob = context.active_object
        if ac_ob.modifiers:
            modfier_lst = [modi.name for modi in ac_ob.modifiers if modi.type == 'NODES']
            if "DamagePro_" not in modfier_lst:
                op = layout.operator('sna.apply_modifer_92c02', text='Add Damage', icon_value=892, emboss=True, depress=False)
                op.sna_modifer = 'DamagePro2'
            else:
                try:
                    attr_DC527 = '["' + str('Input_4' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_DC527, text='Depth', icon_value=0, emboss=False)
                    attr_C5415 = '["' + str('Input_41' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_C5415, text='Density', icon_value=0, emboss=False)
                    attr_461C7 = '["' + str('Input_28' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_461C7, text='Reduce the Depth', icon_value=0, emboss=False)
                    attr_355AA = '["' + str('Input_42' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_355AA, text='Scale', icon_value=0, emboss=False)
                    attr_4C24C = '["' + str('Input_44' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_4C24C, text='Detail', icon_value=0, emboss=False)
                    attr_CA88D = '["' + str('Input_45' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_CA88D, text='Roughness', icon_value=0, emboss=False)
                    attr_5A0FC = '["' + str('Input_40' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_5A0FC, text='Angle', icon_value=0, emboss=False)
                    attr_269FA = '["' + str('Input_10' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_269FA, text='Internal Damage', icon_value=31, emboss=True)
                    attr_CC983 = '["' + str('Input_37' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_CC983, text='Depth', icon_value=0, emboss=False)
                    attr_309C5 = '["' + str('Input_12' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_309C5, text='Density', icon_value=0, emboss=False)
                    attr_1B7E5 = '["' + str('Input_36' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_1B7E5, text='Density 2', icon_value=0, emboss=False)
                    attr_1AC58 = '["' + str('Input_13' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_1AC58, text='Scale', icon_value=0, emboss=False)
                    attr_65120 = '["' + str('Input_34' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_65120, text='Density Damage', icon_value=0, emboss=False)
                    attr_73D5A = '["' + str('Input_14' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_73D5A, text='Seed', icon_value=0, emboss=False)
                    attr_FA01E = '["' + str('Input_15' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_FA01E, text='Steel', icon_value=31, emboss=True)
                    attr_E2258 = '["' + str('Input_39' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_E2258, text='Radius', icon_value=0, emboss=False)
                    attr_0909B = '["' + str('Input_22' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_0909B, text='Amount', icon_value=0, emboss=False)
                    attr_3E541 = '["' + str('Input_33' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_3E541, text='Radius Rods', icon_value=0, emboss=False)
                    attr_A9BBF = '["' + str('Input_23' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_A9BBF, text='Position', icon_value=0, emboss=False)
                    attr_D4536 = '["' + str('Input_24' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_D4536, text='Scale Noise', icon_value=0, emboss=False)
                    attr_D1E43 = '["' + str('Input_25' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_D1E43, text='Power Noise', icon_value=0, emboss=False)
                    attr_06AAB = '["' + str('Input_26' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_06AAB, text='Resolution', icon_value=0, emboss=False)
                    attr_63F1F = '["' + str('Input_27' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_63F1F, text='Count', icon_value=0, emboss=False)
                    attr_52AAC = '["' + str('Input_32' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_52AAC, text='Number of Rods', icon_value=0, emboss=False)
                    attr_7911F = '["' + str('Input_38' + '"]') 
                    layout.prop(bpy.context.view_layer.objects.active.modifiers['DamagePro_'], attr_7911F, text='Entire Grid', icon_value=776, emboss=True)
                    layout.prop(bpy.context.scene, 'sna_new_property', text='Base', icon_value=0, emboss=True)
                    layout.prop(bpy.context.scene, 'sna_new_property_001', text='Damage', icon_value=165, emboss=True)
                    layout.prop(bpy.context.scene, 'sna_new_property_002', text='Steel', icon_value=0, emboss=True)
                except:
                    pass

def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.types.Scene.sna_new_property = bpy.props.PointerProperty(name='New Property', description='', type=bpy.types.Material, update=sna_update_sna_new_property_08739)
    bpy.types.Scene.sna_new_property_001 = bpy.props.PointerProperty(name='New Property 001', description='', type=bpy.types.Material, update=sna_update_sna_new_property_001_D54F3)
    bpy.types.Scene.sna_new_property_002 = bpy.props.PointerProperty(name='New Property 002', description='', type=bpy.types.Material, update=sna_update_sna_new_property_002_CA25C)
    bpy.utils.register_class(SNA_OT_Apply_Modifer_92C02)
    bpy.utils.register_class(SNA_PT_REAL_DAMAGE_420D1)
    bpy.app.translations.register(__package__, GetTranslationDict())
    print(f"{Path(__file__).parent.name} 插件由xz-blender购买分享!感谢支持!")



def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    del bpy.types.Scene.sna_new_property_002
    del bpy.types.Scene.sna_new_property_001
    del bpy.types.Scene.sna_new_property
    bpy.utils.unregister_class(SNA_OT_Apply_Modifer_92C02)
    bpy.utils.unregister_class(SNA_PT_REAL_DAMAGE_420D1)
    bpy.app.translations.unregister(__package__)
